%This program aims at ray trace on basis of travel time.
%This Matlab program is transversed from a FORTRAN programs 

clear;
global water

% open files for input data:water velocity,direct time and shottable
% open a file for water depths and velocities
[filename, pathname] = uigetfile('*.*', 'Enter a file for water velocities');
    [fid1,message]=fopen(filename,'r');

% open file for direct time     
[filename, pathname] = uigetfile('*.*', 'Enter a file for direct time');
    [fid2,message]=fopen(filename,'r');

% open file for shottable     
[filename, pathname] = uigetfile('*.*','Enter the shot_table');
    [fid3,message]=fopen(filename,'r');
    
% open file for output 
[filename, pathname] = uiputfile('*.*', 'Save the relocted OBS position in');
    [fid5,message]=fopen(filename,'w');
    [fid4,message]=fopen('tempfile1','w');
        
prompt={'Enter specified maximal range:','Enter specified least increment:'};
   def={'250','5'};
   dlgTitle='Specify the range and least increment:';
   lineNo=1;
   answer=inputdlg(prompt,dlgTitle,lineNo,def);
 ymax=str2num(char(answer(1)));
 xmax=ymax;
 ydely=str2num(char(answer(2)));
 xdely=ydely;
    
    
%read data from water.vel file
status=fseek(fid1,0,-1);               
water=fscanf(fid1,'%f %f',[2 inf]);    
water=water';
number_water_layer=size(water,1); 

%Extend velocity distribution to greater depths
vel_inc=water(number_water_layer-1,2)-...
    water(number_water_layer-2,2);
dis_inc=water(number_water_layer-1,1)-...
    water(number_water_layer-2,1);
lay_inc=150-number_water_layer;

for j= 1 : lay_inc
    water(number_water_layer+j-1,1)= ...
        water(number_water_layer+j-2,1)+dis_inc;
    water(number_water_layer+j-1,2)=...
        water(number_water_layer+j-2,2)+vel_inc;
end

%read location (Lat&Lon) at which OBS is launched
%status=fseek(fid3,50, -1); 
status=fseek(fid3,0,-1);   
inputline0=fgetl(fid3);
Latitude=fscanf(fid3,'%f',[1 1]);
Longitude=fscanf(fid3,'%f',[1 1]);
for n=0:5
  inputline=fgetl(fid3);
end

pre_position3=ftell(fid3);


fprintf(fid4,'%12.7f %12.7f\n',Latitude,Longitude);

%read head from DirectTime.inp
headDT(1:2)=0;
status=fseek(fid2,0, -1); 
headDT(1)=fscanf(fid2,'%f',[1 1]);
headDT(2)=fscanf(fid2,'%f',[1 1]);
Lat_retrieval=fscanf(fid2,'%f',[1 1]);
Lon_retrieval=fscanf(fid2,'%f\n',[1 1]);

DEPTH=true_depth(headDT(1));  %corrected depth,i.e.,true depth
pre_position2=ftell(fid2);

%find the layer_number just below seabed
i=1;
while water(i,1)<DEPTH
    i=i+1;
    if i>50
        break
    end
end
water_layer_below_seabed=i;

%calculate the interface number at shot
       for i=1:35
           if water(i,1) >= headDT(2)
               interface_at_detonation=i;
               break
           end
       end
      
      %calculate the interface number at seabed
      for j=1:50
           if water(j,1) >= DEPTH
               interface_at_seabed=j;
               break
           end
       end
       
       %calculate which layer(at shot/seabed)is the shallower one
       if headDT(2) < DEPTH
           upper_layer=interface_at_detonation;
           lower_layer=water_layer_below_seabed;
           upper_depth=headDT(2);
           lower_depth=DEPTH;
       else
           upper_layer=water_layer_below_seabed;
           lower_layer=interface_at_detonation;
           upper_depth=DEPTH;
           lower_depth=headDT(2);
       end

       %find the maximum, minimum and mean velocity of water
       Vmax=water(upper_layer,2);
       Vmin=water(upper_layer,2);
       
       if (lower_layer-1) >= upper_layer
           for k=upper_layer:(lower_layer-1)
               if water(k,2) > Vmax
                  Vmax=water(k,2);
               elseif water(k,2) < Vmin
                  Vmin=water(k,2);
               else
           end
       end
       
       %problem could occur at the following part
       if lower_layer == upper_layer
           Vmean=water(upper_layer,2);%in fact,this part has no use
       else
           Dint=lower_depth-upper_depth;
           Vmean=(water(upper_layer,1)-upper_depth)/Dint...
               *water(upper_layer,2);
           if lower_layer ~= (upper_layer+1)
               n=lower_layer-2;
               for i=upper_layer : n
                   Vmean=(water(i+1,1)-water(i,1))/...
                       Dint*water(i,2)+Vmean;
               end
           end
               Vmean=Vmean+(lower_depth-water(lower_layer-1,1))/...
                   Dint*water(lower_layer-1,2);
       end
           
       velocity_check=Vmax*Vmax-Vmin*Vmin;
       Depth_difference=DEPTH-headDT(2);
       
%read shot_number and direct_time from DirectTime.inp file
status=fseek(fid3,0, 1);
P_fid3=ftell(fid3);
status=fseek(fid2,0, 1);
P_fid2=ftell(fid2);

Direct_time(1:2)=0;
status=fseek(fid3,pre_position3, -1);
status=fseek(fid2,pre_position2, -1); 
position_fid2=ftell(fid2);
position_fid3=ftell(fid3);


h = waitbar(0,'It is ray tracing,Please wait...');
while feof(fid2) ==0      %read data if not end of file
      Direct_time=fscanf(fid2,'%d %f',[2,1])';
      position_fid2=ftell(fid2);
      waitbar(position_fid2/P_fid2,h)
      if isempty(Direct_time)==0
          Direct_time=Direct_time';
      else 
          break;
      end
      time_difference=Direct_time(2)/1000.0;
      
      shot_table(1:8)=0;
      while feof(fid3) ==0  
         shot_table=fscanf(fid3,'%d %d %d %d %f %f %f %f',[8,1]); 
         position_fid3=ftell(fid3);
         if (Direct_time(1)) == (shot_table(1))
             break
         end
      end
      shot_table(8)=abs(shot_table(8));
          
      Depth_check=Depth_difference*Depth_difference/...
           (time_difference*time_difference);
       
       if (velocity_check >= Depth_check)
           Velocity_del=Vmax*Vmax-Depth_check;
           if Velocity_del <= 0
              Velocity_del=0.0001;
           end
           Vmin=sqrt(Velocity_del)+0.1;
       end
             
       % Calculate maximal and minimal P value for direct water
       QC(1:3)=0;
       COS=Depth_difference/(time_difference*Vmax);
       if COS >= 1.0
           COS=1.0-0.1e-09;
       end
       QC(2)=sqrt(1.0 -COS*COS)/Vmin;
       
       COS=Depth_difference/(time_difference*Vmin);
       if COS >= 1.0
           COS=1.0-0.1e-09;
       end
       QC(1)=sqrt(1.0 - COS*COS)/Vmax;
     
       %Calculate the horizontal distance between shot and OBS
       Distance= get_distance(QC,Vmean,DEPTH,...
           upper_layer,headDT(2),...
           time_difference,lower_depth,upper_depth);
       Distance=Distance/1000.0;
       Distance_diferrence=Distance-shot_table(8);
       fprintf(fid4,'%d %10.5f %11.5f %7.3f %7.3f %7.3f\n',...
           Direct_time(1),shot_table(6),shot_table(7),...
           Distance,shot_table(8),Distance_diferrence);
  end
end
close(h);
fclose(fid1);
fclose(fid2);
fclose(fid3);
fclose(fid4);







%This program aims at re_locating OBS

global A A0 A2 A4 A6 A8 B E1 E2 F RECIPF k0 degrad

%% %Ellipsoidal parameters from Clark 1866 ellipsoid
%% format long A
%% format long B

A=6378206.4;
RECIPF=294.97898;
K0=0.9996;
RADDEG=57.29577951;
FE=500000.0;
F=1.0/RECIPF;
B=A-A*F;
E1=(A*A-B*B)/(A*A);
E2=(A*A-B*B)/(B*B);
degrad=1.7453292519945e-2;
DELM=100.0;

%Arc length constants:
A0=1.-0.25*E1-0.046875*E1*E1-0.01953125*E1^3.0-175.0/16384.*E1^4.0;
A2=0.375*(E1+0.25*E1*E1+0.1171875*E1^3.0-455.0/4096.0*E1^4.0);
A4=0.05859375*(E1*E1+0.75*E1^3.0-77.0/128.0*E1^4.0);
A6=35.0/3072.0*(E1^3.0-1.28125*E1^4.0);
A8=-315.0/131072.0*E1^4.0;

[fid4,message]=fopen('tempfile1','r');  
[fid6,message]=fopen('tempfile2','w');
%read location (Lat&Lon) at which OBS is launched
status=fseek(fid4, 0, -1);
North1=fscanf(fid4,'%f' ,[1 1]);
East1=fscanf(fid4,'%f' ,[1 1]);

%calculate the central meridian in each zone
 CM=round(East1);
 cm=-177:6:177;
 n=size(cm');
 for i=1:n
     if CM < cm(i)+3 & CM > cm(i)-3
         CM=cm(i);
         break
     end
 end
 
%transfer Lat&lon of OBS position into UTM
UTM=latlon(North1,East1,CM);
UTMretrieval=latlon(Lat_retrieval,Lon_retrieval,CM);

North=UTM(1);
East=UTM(2);
Northretrival=UTMretrieval(1);
Eastretrival=UTMretrieval(2);

%input data from fid1:input file
obs_loc=fscanf(fid4,'%d %f %f %f %f %f',[6,inf]);
obs_loc=obs_loc'; 
[number_of_record,n]=size(obs_loc);
 N=number_of_record;
 
 %fprintf(fid5,'%s %s %s\n',c1,c2,c3);
 fprintf(fid5,'Deployment: %9.5f %9.5f\n',North1,East1);

 fprintf(fid5,'Retrival: %9.5f %9.5f\n',Lat_retrieval,Lon_retrieval);
 
 fprintf(fid5,'Range: %4.1f; Increment: %4.1f; Number of record: %5d;\n',...
    ymax,ydely,number_of_record);

fprintf(fid6,'%9.5f %9.5f %4.1f %4.1f %5d\n',...
    North1,East1,ymax,ydely,number_of_record);

 L=2.0*ymax/ydely+1;
 M=2.0*xmax/xdely+1;
 

east=(East-xdely*((M+1.0)/2.0-1.0)):...
    xdely*(-1.0+M)/(M-1):...
    (East-xdely*((M+1.0)/2.0-M));

north=(North-ydely*((L+1.0)/2.0-1.0)):...
    ydely*(-1.0+L)/(L-1):...
    (North-ydely*((L+1.0)/2.0-L));

DELR(1:L,1:M)=0;
north_east(1:N,1:2)=0;

%a,b,c are the coeficients of a linear equation aX+bY+c=0%
a=0;
b=0;
c=0;
%r,s,t,w are tempery variables for calculating a,b,c%
r=0;
t=0;
s=0;
w=0;
for i=1:N
    north_east(i,:)=latlon_utm(obs_loc(i,2),obs_loc(i,3),CM);
    s=s+north_east(i,2)*north_east(i,2);
    t=t+north_east(i,2);
    w=w+north_east(i,2)*north_east(i,1);
    r=r+north_east(i,1);
end
a=N*w-t*r;
b=t*t-N*s;
c=-(b*r+a*t)/N;
h= waitbar(0,'It is re-locating, Please wait...');
for K=1:L
    for J=1:M
        for I=1:N
            DELN=(north(K)-north_east(I,1))*1.0e-3;
            DELE=(east(J)-north_east(I,2))*1.0e-3;
            RR2=sqrt(DELN*DELN+DELE*DELE);
            DDL(I)=RR2-obs_loc(I,4);
            DELR(J,K)=DELR(J,K)+DDL(I)*DDL(I);
        end
        DELR(J,K)=sqrt(DELR(J,K)/N);
        if DELR(J,K) < DELM
            DELM=DELR(J,K);
            for i=1:N
                DDLM(i)=DDL(i);
            end
            KMIN=K;
            JMIN=J;
        end
        waitbar(K*J/(L*M),h)
    end
end
close(h)

%Compute the position of OBS based on the computed minimum

delty=ydely*((L+1.0)/2.0-KMIN);
deltx=xdely*((M+1.0)/2.0-JMIN);
YOBSM=North-delty;
XOBSM=East-deltx;
drift=sqrt(deltx*deltx+delty*delty);

for i=1:N   %re-consider this N
    fprintf(fid6,'%d %10.5f %10.5f %10.5f %10.5f\n',...
    obs_loc(i,1),obs_loc(i,2),obs_loc(i,3),obs_loc(i,4),DDLM(i));
end

LON_LAT=utm(YOBSM,XOBSM,CM);
YOBSM1=LON_LAT(1);
XOBSM1=LON_LAT(2);

fprintf(fid5,'the best  fit OBS location is :%11.6f %11.6f %8.5f\n',...
    YOBSM1,XOBSM1,DELM);

%biginning of the first insert

second_XOBSM=(b*b*XOBSM-a*b*YOBSM-a*c)/(a*a+b*b);
second_YOBSM=(a*a*YOBSM-a*b*XOBSM-b*c)/(a*a+b*b);
second_XOBSM=second_XOBSM+second_XOBSM-XOBSM;
second_YOBSM=second_YOBSM+second_YOBSM-YOBSM;


second_LON_LAT=utm(second_YOBSM,second_XOBSM,CM);
second_YOBSM1=second_LON_LAT(1);
second_XOBSM1=second_LON_LAT(2);
fprintf(fid5,'the conjugate OBS location is :%11.6f %11.6f\n',...
    second_YOBSM1,second_XOBSM1);
% begining the second insert


fprintf(fid5,'the best  fit OBS drifts:%10.5f\n',drift);
if drift > xmax
    fprintf(fid5,'Please increase the range for searching this OBS!\n');
end

fclose(fid4);
fclose(fid5);
fclose(fid6);


f=figure('name','The Relocated  OBS Position','NumberTitle','off');
DELR=DELR';
level=[0 0.005 0.01 0.02 0.04 0.08 0.12 0.16 0.2 ...
         0.5 1 1.5 2.0];
label=[0 0.005 0.01 0.02 0.04 0.08 0.5 2.0];
      

num_xtick=(east(M)-east(1))/10;
num_ytick=(north(L)-north(1))/10;
axis off
x_tick=east(1):num_xtick:east(M);
[xx,xnum]=size(x_tick);
maxlabel=0.5*(east(M)+east(1));
for i=1:xnum
    xlabel(i)={num2str(round(x_tick(i)-maxlabel))};
end

y_tick=north(1):num_ytick:north(L);
[xx,ynum]=size(y_tick);
maxlabel=0.5*(north(M)+north(1));
for j=1:ynum
    ylabel(j)={num2str(round(y_tick(j)-maxlabel))};
end

hold on
axes('YLim',[north(1) north(L)],'Ytick',y_tick,...
    'YTickmode','manual','YTickLabel',ylabel,...
    'YTickLabelMode','manual',...
    'XLim',[east(1) east(M)],'Xtick',x_tick,...
    'XTickmode','manual','XTickLabel',xlabel,...
    'XTickLabelMode','manual')
box on
grid on
hold on

axis square;
hold on

[hh,hc]=contour(east,north,DELR,level);

hold on
plot(XOBSM,YOBSM,'r+')


hold on
plot(XOBSM,YOBSM,'rO')

if second_YOBSM > north(1) & second_YOBSM < north(L)...
          & second_XOBSM > east(1) & second_XOBSM < east(M) 
hold on
plot(second_XOBSM,second_YOBSM,'m+')

hold on
plot(second_XOBSM,second_YOBSM,'gO')
end

hold on
plot(East,North,'b*')
plot(Eastretrival,Northretrival,'ro')


%label=0.01:0.04:0.2;
hold on
clabel(hh,label)
%clabel(hh,'manual');

hold on
title(inputline0)

hold on
pXOBSM=east(M)-xmax;
pYOBSM=north(M)-ymax/20;
East=num2str(East1);
North=num2str(North1);
inputline=['Deploy :',North,' ',East];
text(pXOBSM,pYOBSM,inputline)

pXOBSM=east(M)-xmax;
pYOBSM=north(M)-2.5*ymax/20;
East=num2str(Lon_retrieval);
North=num2str(Lat_retrieval);
inputline=['Recover:',North,' ',East];
text(pXOBSM,pYOBSM,inputline)

pXOBSM=east(M)-xmax;
pYOBSM=north(M)-4*ymax/20;
XOBSM1=num2str(XOBSM1);
YOBSM1=num2str(YOBSM1);
inputline=['Relocat:',YOBSM1,' ',XOBSM1];
text(pXOBSM,pYOBSM,inputline)

pXOBSM=east(M)-xmax;
pYOBSM=north(M)-5.5*ymax/20;
East=num2str(second_XOBSM1);
North=num2str(second_YOBSM1);
inputline=['Mirror :',North,' ',East];
text(pXOBSM,pYOBSM,inputline)

pXOBSM=east(M)-xmax;
pYOBSM=north(M)-7*ymax/20;
newposition=num2str(DELM);
inputline=['Err: ',newposition];
text(pXOBSM,pYOBSM,inputline)

pXOBSM=east(M)-xmax;
pYOBSM=north(M)-8.5*ymax/20;
newposition=num2str(headDT(1));
inputline=['Water depth: ',newposition,'m'];
text(pXOBSM,pYOBSM,inputline)

pXOBSM=east(M)-xmax;
pYOBSM=north(M)-10*ymax/20;
newposition=num2str(drift);
inputline=['The OBS drifts ',newposition,'m'];
text(pXOBSM,pYOBSM,inputline)

if drift > xmax
    fprintf(-east(M),0,'Please increase the range for searching this OBS!\n');
end

for i=1:N
    if north_east(i,1) > north(1) & north_east(i,1) < north(L)...
            & north_east(i,2) > east(1) & north_east(i,2)...
            < east(M) 
       hold on
       plot(north_east(i,2),north_east(i,1),'g+')
       plot(north_east(i,2),north_east(i,1),'gO')
    end
end
